#ifndef OPENGLBAUMZEIGER_H
#define OPENGLBAUMZEIGER_H

#include <QGLWidget>
#include <QPoint>
#include <QMouseEvent>

class OpenGLBaumZeiger : public QGLWidget
{
    Q_OBJECT

public:
    OpenGLBaumZeiger(QWidget *parent);
    ~OpenGLBaumZeiger();

    QSize minimumSizeHint() const { return QSize(200,200); }

    int gebeRekTiefe() const { return rekTiefe; }
    int gebeWinkel() const { return 2.0*winkel; }
    int gebeWinkelSkal() const { return winkelSkal*100.0; }
    int gebeLaenge() const { return laenge*100.0; }
    int gebeVerkuerzung() const { return verkuerzung*100.0; }

public slots:
    void setzeRekTiefe(int rekTiefe) { this->rekTiefe=rekTiefe; erstelleBaum(); updateGL(); }
    void setzeWinkel(int winkel) { this->winkel=winkel*0.5; erstelleBaum(); updateGL(); }
    void setzeLaenge(int laenge) { this->laenge=laenge*0.01; erstelleBaum(); updateGL(); }
    void setzeVerkuerzung(int verkuerzung) { this->verkuerzung=verkuerzung*0.01; erstelleBaum(); updateGL(); }
    void setzeWinkelSkal(int winkelskal) { winkelSkal=winkelskal*0.01; erstelleBaum(); updateGL(); }

protected: // protected methods
    void initializeGL();
    void resizeGL(int w, int h);
    void paintGL();
    void mousePressEvent(QMouseEvent *e) {letzteMausPos = e->pos(); }
    void mouseMoveEvent(QMouseEvent *e);
    void erstelleBaum();
    void erstelleBaumRek(float laenge,float winkel,int rek);

protected: // protected attributes
    float rotX;
    float rotY;
    float zDist;
    int rekTiefe;
    float winkel;
    float laenge;
    float verkuerzung;
    float winkelSkal;
    QPoint letzteMausPos;
    GLuint objektRef;
};

#endif // OPENGLBAUMZEIGER_H
